## tao-json 0.0+git20200604.f357d72

=== src/test/json/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.3.0 FATAL_ERROR)

set(testsources
  big_list_of_naughty_strings.cpp
  binding_array.cpp
  binding_factory.cpp
  binding_object.cpp
  binding_versions.cpp
  cbor.cpp
  cbor_parts_parser.cpp
  contrib_diff.cpp
  contrib_get.cpp
  contrib_patch_add.cpp
  contrib_patch_copy.cpp
  contrib_patch_move.cpp
  contrib_patch_remove.cpp
  contrib_patch_replace.cpp
  contrib_patch_test.cpp
  contrib_position.cpp
  contrib_reference.cpp
  contrib_schema.cpp
  contrib_traits.cpp
  double.cpp
  enable_implicit_constructor.cpp
  escape.cpp
  events_binary_to.cpp
  events_compare.cpp
  events_debug.cpp
  events_hash.cpp
  events_to_stream.cpp
  events_to_string.cpp
  include_json.cpp
  integer.cpp
  jaxn_ostream.cpp
  jaxn_parse.cpp
  jaxn_parts_parser.cpp
  json_ostream.cpp
  json_parse.cpp
  json_parts_parser.cpp
  json_pointer.cpp
  key_camel_case_to_snake_case.cpp
  key_snake_case_to_camel_case.cpp
  literal.cpp
  msgpack.cpp
  object_construction.cpp
  opaque_pointer.cpp
  operators.cpp
  optional.cpp
  public_base.cpp
  self_contained.cpp
  sha256.cpp
  string_view.cpp
  temporary_parsing.cpp
  type.cpp
  ubjson.cpp
  uri_fragment.cpp
  validate_event_interfaces.cpp
  validate_utf8.cpp
  value_access.cpp
  value_basics.cpp
  value_create.cpp
  value_ptr.cpp
  value_subscript.cpp
  with_arguments.cpp
)

# file (GLOB ...) is used to validate the above list of test_sources
file (GLOB glob_test_sources RELATIVE ${CMAKE_CURRENT_LIST_DIR} *.cpp)

foreach (testsourcefile ${testsources})
  if (${testsourcefile} IN_LIST glob_test_sources)
    list (REMOVE_ITEM glob_test_sources ${testsourcefile})
  else ()
    message (SEND_ERROR "File ${testsourcefile} is missing from src/test/json")
  endif ()
  get_filename_component (exename ${testsourcefile} NAME_WE)
  set (exename "tao-json-test-${exename}")
  add_executable (${exename} ${testsourcefile})
  target_link_libraries (${exename} PRIVATE taocpp::json)
  set_target_properties (${exename} PROPERTIES
    CXX_STANDARD 11
    CXX_STANDARD_REQUIRED ON
    CXX_EXTENSIONS OFF
  )
  if (MSVC)
    target_compile_options (${exename} PRIVATE /W4 /WX /utf-8)
  else ()
    target_compile_options (${exename} PRIVATE -pedantic -Wall -Wextra -Wshadow -Werror)
  endif ()
  add_test (NAME ${exename} WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/../../.. COMMAND ${CMAKE_CURRENT_BINARY_DIR}/${exename})
endforeach (testsourcefile)

if (glob_test_sources)
  foreach (ignored_source_file ${glob_test_sources})
    message (SEND_ERROR "File ${ignored_source_file} in src/test/json is ignored")
  endforeach (ignored_source_file)
endif ()

=== debian/changelog ===
tao-json (0.0+git20200604.f357d72-2) unstable; urgency=medium

  * Team upload.
  * Remove trailing whitespace in debian/copyright (routine-update)

 -- Andreas Tille <tille@debian.org>  Mon, 20 Jul 2020 22:01:20 +0200

tao-json (0.0+git20200604.f357d72-1) unstable; urgency=medium

  * Initial release (Closes: #964392)

 -- Shayan Doust <hello@shayandoust.me>  Mon, 06 Jul 2020 12:43:45 +0100

=== debian/control ===
Source: tao-json
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Shayan Doust <hello@shayandoust.me>
Section: libdevel
Priority: optional
Build-Depends: debhelper-compat (= 13)
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/med-team/tao-json
Vcs-Git: https://salsa.debian.org/med-team/tao-json.git
Homepage: https://github.com/taocpp/json
Rules-Requires-Root: no

Package: tao-json-dev
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: multifunctional and zero-dependency C++ header-only JSON library
 taoJSON is a zero-dependency C++ header-only JSON library that provides
 a generic Value Class, uses Type Traits to interoperate with C++ types,
 uses an Events Interface to convert to and from JSON, JAXN, CBOR,
 MsgPack and UBJSON, and much, much more.

Package: tao-json-examples
Architecture: all
Depends: ${misc:Depends}
Recommends: tao-json-dev
Description: multifunctional and zero-dependency C++ header-only JSON library (examples)
 taoJSON is a zero-dependency C++ header-only JSON library that provides
 a generic Value Class, uses Type Traits to interoperate with C++ types,
 uses an Events Interface to convert to and from JSON, JAXN, CBOR,
 MsgPack and UBJSON, and much, much more.
 .
 This package accommodates tao-json-dev package, and provides example C++
 sources featuring the usage and functionality of this library.

=== debian/watch ===
version=4

opts="mode=git,pretty=0.0+git%cd.%h" \
  https://github.com/taocpp/json.git HEAD

## tao-json 1.0.0~beta14

=== Makefile ===
# The Art of C++
# Copyright (c) 2015-2023 Dr. Colin Hirsch and Daniel Frey
# Please see LICENSE for license or visit https://github.com/taocpp/json

.SUFFIXES:
.SECONDARY:

ifeq ($(OS),Windows_NT)
UNAME_S := $(OS)
ifeq ($(shell gcc -dumpmachine),mingw32)
MINGW_CXXFLAGS = -U__STRICT_ANSI__
endif
else
UNAME_S := $(shell uname -s)
endif

# For Darwin (Mac OS X / macOS) we assume that the default compiler
# clang++ is used; when $(CXX) is some version of g++, then
# $(CXXSTD) has to be set to -std=c++17 (or newer) so
# that -stdlib=libc++ is not automatically added.

ifeq ($(CXXSTD),)
CXXSTD := -std=c++17
ifeq ($(UNAME_S),Darwin)
CXXSTD += -stdlib=libc++
endif
endif

# Ensure strict standard compliance and no warnings, can be
# changed if desired.

CPPFLAGS ?= -pedantic -Iinclude -Iexternal/PEGTL/include
CXXFLAGS ?= -Wall -Wextra -Wshadow -Werror -O3 $(MINGW_CXXFLAGS)

HEADERS := $(shell find include -name '*.hpp')
SOURCES := $(shell find src -name '*.cpp')
DEPENDS := $(SOURCES:%.cpp=build/%.d)
BINARIES := $(SOURCES:%.cpp=build/%)

UNIT_TESTS := $(filter build/src/test/%,$(BINARIES))

.PHONY: all
all: compile check

.PHONY: compile
compile: $(BINARIES)

.PHONY: check
check: $(UNIT_TESTS)
	@set -e; for T in $(UNIT_TESTS); do echo $$T; $$T > /dev/null; done

.PHONY: clean
clean:
	@rm -rf build/*
	@find . -name '*~' -delete

build/%.d: %.cpp Makefile
	@mkdir -p $(@D)
	$(CXX) $(CXXSTD) $(CPPFLAGS) -MM -MQ $@ $< -o $@

build/%: %.cpp build/%.d
	$(CXX) $(CXXSTD) $(CPPFLAGS) $(CXXFLAGS) $< $(LDFLAGS) -o $@

ifeq ($(findstring $(MAKECMDGOALS),clean),)
-include $(DEPENDS)
endif

=== src/example/json/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8...3.19)

set(examplesources
  cbor_to_jaxn.cpp
  cbor_to_json.cpp
  cbor_to_msgpack.cpp
  cbor_to_pretty_jaxn.cpp
  cbor_to_pretty_json.cpp
  cbor_to_ubjson.cpp
  jaxn_to_cbor.cpp
  jaxn_to_cplusplus.cpp
  jaxn_to_jaxn.cpp
  jaxn_to_msgpack.cpp
  jaxn_to_pretty_jaxn.cpp
  jaxn_to_ubjson.cpp
  json_to_cbor.cpp
  json_to_json.cpp
  json_to_msgpack.cpp
  json_to_pretty_json.cpp
  json_to_ubjson.cpp
  msgpack_to_cbor.cpp
  msgpack_to_jaxn.cpp
  msgpack_to_json.cpp
  msgpack_to_pretty_jaxn.cpp
  msgpack_to_pretty_json.cpp
  msgpack_to_ubjson.cpp
  printf_doubles.cpp
  ubjson_to_cbor.cpp
  ubjson_to_jaxn.cpp
  ubjson_to_json.cpp
  ubjson_to_msgpack.cpp
  ubjson_to_pretty_jaxn.cpp
  ubjson_to_pretty_json.cpp
  validate_event_order.cpp
  validate_integer.cpp
)

# file(GLOB ...) is used to validate the above list of example_sources
file(GLOB glob_example_sources RELATIVE ${CMAKE_CURRENT_LIST_DIR} *.cpp)

foreach(examplesourcefile ${examplesources})
  if(${examplesourcefile} IN_LIST glob_example_sources)
    list(REMOVE_ITEM glob_example_sources ${examplesourcefile})
  else()
    message(SEND_ERROR "File ${examplesourcefile} is missing from src/example/json")
  endif()
  get_filename_component(exename ${examplesourcefile} NAME_WE)
  set(exename "tao-json-example-${exename}")
  add_executable(${exename} ${examplesourcefile})
  target_link_libraries(${exename} PRIVATE taocpp::json)
  set_target_properties(${exename} PROPERTIES
    CXX_STANDARD 11
    CXX_STANDARD_REQUIRED ON
    CXX_EXTENSIONS OFF
  )
  if(MSVC)
    target_compile_options(${exename} PRIVATE /W4 /WX /utf-8)
  else()
    target_compile_options(${exename} PRIVATE -pedantic -Wall -Wextra -Wshadow -Werror)
  endif()
endforeach()

if(glob_example_sources)
  foreach(ignored_source_file ${glob_example_sources})
    message(SEND_ERROR "File ${ignored_source_file} in src/example/json is ignored")
  endforeach()
endif()

=== debian/changelog ===
tao-json (1.0.0~beta14-1) unstable; urgency=medium

  * Team upload.

  [ zhangdandan ]
  * Add support for loongarch64
    Closes: #1076129

  [ Andreas Tille ]
  * New upstream version
  * Point watch files to github tags

  [ Étienne Mollier ]
  * fuzzy-match.patch: new: fix build failure on i386. (Closes: #1103123)
  * d/control: build depends on tao-pegtl-dev.
  * d/rules: set CPATH to fetch ./include.
  * d/control: declare compliance to standards version 4.7.2.
  * d/copyright: remove superfluous entries.
  * d/u/metadata: document upstream repository.

 -- Étienne Mollier <emollier@debian.org>  Thu, 01 May 2025 18:26:32 +0200

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,9 @@
 Uploaders: Shayan Doust <hello@shayandoust.me>
 Section: libdevel
 Priority: optional
-Build-Depends: debhelper-compat (= 13)
-Standards-Version: 4.5.0
+Build-Depends: debhelper-compat (= 13),
+               tao-pegtl-dev
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/tao-json
 Vcs-Git: https://salsa.debian.org/med-team/tao-json.git
 Homepage: https://github.com/taocpp/json

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8
export CPATH=$(CURDIR)/include
include /usr/share/dpkg/default.mk

%:
	dh $@

=== debian/watch ===
version=4

opts="mode=git,dversionmangle=auto,uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/\$1~\$2\$3/" \
   https://github.com/taocpp/json.git refs/tags/v?@ANY_VERSION@

#opts="mode=git,pretty=0.0+git%cd.%h" \
#  https://github.com/taocpp/json.git HEAD

## tao-json 1.0.0~beta14%2Breally0.0%2Bgit20200604.f357d72

=== src/example/json/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.3.0 FATAL_ERROR)

set (examplesources
  cbor_to_jaxn.cpp
  cbor_to_json.cpp
  cbor_to_msgpack.cpp
  cbor_to_pretty_jaxn.cpp
  cbor_to_pretty_json.cpp
  cbor_to_ubjson.cpp
  jaxn_to_cbor.cpp
  jaxn_to_cplusplus.cpp
  jaxn_to_jaxn.cpp
  jaxn_to_msgpack.cpp
  jaxn_to_pretty_jaxn.cpp
  jaxn_to_ubjson.cpp
  json_to_cbor.cpp
  json_to_json.cpp
  json_to_msgpack.cpp
  json_to_pretty_json.cpp
  json_to_ubjson.cpp
  msgpack_to_cbor.cpp
  msgpack_to_jaxn.cpp
  msgpack_to_json.cpp
  msgpack_to_pretty_jaxn.cpp
  msgpack_to_pretty_json.cpp
  msgpack_to_ubjson.cpp
  printf_doubles.cpp
  ubjson_to_cbor.cpp
  ubjson_to_jaxn.cpp
  ubjson_to_json.cpp
  ubjson_to_msgpack.cpp
  ubjson_to_pretty_jaxn.cpp
  ubjson_to_pretty_json.cpp
  validate_event_order.cpp
  validate_integer.cpp
)

# file (GLOB ...) is used to validate the above list of example_sources
file (GLOB glob_example_sources RELATIVE ${CMAKE_CURRENT_LIST_DIR} *.cpp)

foreach (examplesourcefile ${examplesources})
  if (${examplesourcefile} IN_LIST glob_example_sources)
    list (REMOVE_ITEM glob_example_sources ${examplesourcefile})
  else ()
    message (SEND_ERROR "File ${examplesourcefile} is missing from src/example/json")
  endif ()
  get_filename_component (exename ${examplesourcefile} NAME_WE)
  set (exename "tao-json-example-${exename}")
  add_executable (${exename} ${examplesourcefile})
  target_link_libraries (${exename} PRIVATE taocpp::json)
  set_target_properties (${exename} PROPERTIES
    CXX_STANDARD 11
    CXX_STANDARD_REQUIRED ON
    CXX_EXTENSIONS OFF
  )
  if (MSVC)
    target_compile_options (${exename} PRIVATE /W4 /WX /utf-8)
  else ()
    target_compile_options (${exename} PRIVATE -pedantic -Wall -Wextra -Wshadow -Werror)
  endif ()
endforeach (examplesourcefile)

if (glob_example_sources)
  foreach (ignored_source_file ${glob_example_sources})
    message (SEND_ERROR "File ${ignored_source_file} in src/example/json is ignored")
  endforeach (ignored_source_file)
endif ()

## tao-json 1.0.0~beta14+really0.0+git20200604.f357d72

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.8.0 FATAL_ERROR)

project (taocpp-json VERSION 1.0.0 LANGUAGES CXX)

# installation directories
set (TAOCPP_JSON_INSTALL_INCLUDE_DIR "include" CACHE STRING "The installation include directory")
set (TAOCPP_JSON_INSTALL_DOC_DIR "share/doc/tao/json" CACHE STRING "The installation doc directory")
set (TAOCPP_JSON_INSTALL_CMAKE_DIR "share/taocpp-json/cmake" CACHE STRING "The installation cmake directory")

# define a header-only library
add_library (json INTERFACE)
add_library (taocpp::json ALIAS json)
target_include_directories (json INTERFACE
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:${TAOCPP_JSON_INSTALL_INCLUDE_DIR}>
)

# require C++17
target_compile_features (json INTERFACE cxx_std_17)

# testing
enable_testing ()
option (TAOCPP_JSON_BUILD_TESTS "Build test programs" ON)
if (TAOCPP_JSON_BUILD_TESTS)
  add_subdirectory (src/test/json)
endif ()

# examples
option (TAOCPP_JSON_BUILD_EXAMPLES "Build example programs" ON)
if (TAOCPP_JSON_BUILD_EXAMPLES)
  add_subdirectory (src/example/json)
endif ()

# install and export target
install (TARGETS json EXPORT taocpp-json-targets)

install (EXPORT taocpp-json-targets
  FILE taocpp-json-config.cmake
  NAMESPACE taocpp::
  DESTINATION ${TAOCPP_JSON_INSTALL_CMAKE_DIR}
)

install (DIRECTORY include/ DESTINATION ${TAOCPP_JSON_INSTALL_INCLUDE_DIR})
install (FILES LICENSE DESTINATION ${TAOCPP_JSON_INSTALL_DOC_DIR})

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # The Art of C++
-# Copyright (c) 2015-2023 Dr. Colin Hirsch and Daniel Frey
+# Copyright (c) 2015-2020 Dr. Colin Hirsch and Daniel Frey
 # Please see LICENSE for license or visit https://github.com/taocpp/json
 
 .SUFFIXES:
@@ -29,13 +29,17 @@
 # Ensure strict standard compliance and no warnings, can be
 # changed if desired.
 
-CPPFLAGS ?= -pedantic -Iinclude -Iexternal/PEGTL/include
+CPPFLAGS ?= -pedantic
 CXXFLAGS ?= -Wall -Wextra -Wshadow -Werror -O3 $(MINGW_CXXFLAGS)
+
+CLANG_TIDY ?= clang-tidy
 
 HEADERS := $(shell find include -name '*.hpp')
 SOURCES := $(shell find src -name '*.cpp')
 DEPENDS := $(SOURCES:%.cpp=build/%.d)
 BINARIES := $(SOURCES:%.cpp=build/%)
+
+CLANG_TIDY_HEADERS := $(filter-out include/tao/json/external/% include/tao/json/internal/endian_win.hpp,$(HEADERS))
 
 UNIT_TESTS := $(filter build/src/test/%,$(BINARIES))
 
@@ -49,6 +53,15 @@
 check: $(UNIT_TESTS)
 	@set -e; for T in $(UNIT_TESTS); do echo $$T; $$T > /dev/null; done
 
+build/%.clang-tidy: % .clang-tidy
+	$(CLANG_TIDY) -quiet $< -- $(CXXSTD) -Iinclude $(CPPFLAGS) $(CXXFLAGS) $(LDFLAGS) 2>/dev/null
+	@mkdir -p $(@D)
+	@touch $@
+
+.PHONY: clang-tidy
+clang-tidy: $(CLANG_TIDY_HEADERS:%=build/%.clang-tidy) $(SOURCES:%=build/%.clang-tidy)
+	@echo "All $(words $(CLANG_TIDY_HEADERS) $(SOURCES)) clang-tidy tests passed."
+
 .PHONY: clean
 clean:
 	@rm -rf build/*
@@ -56,10 +69,10 @@
 
 build/%.d: %.cpp Makefile
 	@mkdir -p $(@D)
-	$(CXX) $(CXXSTD) $(CPPFLAGS) -MM -MQ $@ $< -o $@
+	$(CXX) $(CXXSTD) -Iinclude $(CPPFLAGS) -MM -MQ $@ $< -o $@
 
 build/%: %.cpp build/%.d
-	$(CXX) $(CXXSTD) $(CPPFLAGS) $(CXXFLAGS) $< $(LDFLAGS) -o $@
+	$(CXX) $(CXXSTD) -Iinclude $(CPPFLAGS) $(CXXFLAGS) $< $(LDFLAGS) -o $@
 
 ifeq ($(findstring $(MAKECMDGOALS),clean),)
 -include $(DEPENDS)

=== debian/changelog ===
tao-json (1.0.0~beta14+really0.0+git20200604.f357d72-1) unstable; urgency=medium

  * Team upload.
  * Undo all the changes introduced in 1.0.0~beta14-1 to repair
    regressions affecting tao-config and xenium, in compliance with the
    ongoing freeze policy for the upcoming trixie release.  The only
    change which is preserved is fuzzy-match.patch which addresses the
    release critical bug #1103123.  (Closes: #1104656, #1104658)

 -- Étienne Mollier <emollier@debian.org>  Thu, 05 Jun 2025 20:45:15 +0200
